package Gravitation;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;
import java.util.ArrayList;
import java.util.List;

import javax.imageio.ImageIO;
import javax.imageio.stream.ImageInputStream;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.lwjgl.BufferUtils;
import org.lwjgl.LWJGLException;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.ARBVertexBufferObject;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GLContext;
import org.lwjgl.util.glu.GLU;
import org.newdawn.slick.opengl.Texture;
import org.lwjgl.opengl.ARBMultitexture;
import org.lwjgl.opengl.ARBMultisample;

import a3rLoader.Loader;
import a3rLoader.Model;
import a3rLoader.Particle;

import Gravitation.world.Sphere;
import Gravitation.world.Vector;
import Gravitation.world.World;


import static org.lwjgl.opengl.GL11.*;
import static org.lwjgl.opengl.GL12.*;
import static org.lwjgl.opengl.GL13.*;

public class Gravitation extends Canvas implements Runnable  {
	public static final int WIDTH = 1024;
	public static final int HEIGHT = 768;
	
	OpenGL opengl;
	Control control = new Control();
	public boolean gameRunning = false;
	int i = 0 ;
	
	//FloatBuffer textureBuffer = BufferUtils.createFloatBuffer(0);
	float[] mass;
	public static List<Float> tringleList;
	
	public static List<Float> quadCoordList = new ArrayList<Float>(), textureList = new ArrayList<Float>();
	FloatBuffer coordBuffer = BufferUtils.createFloatBuffer(0), textureBuffer = BufferUtils.createFloatBuffer(0);
	float[] coordMass, textureMass;
	
	
	FloatBuffer colors, vertices, textures, vertexData;		//  
	
	//public static List<Float> textureList = new ArrayList<Float>();
	
	boolean done = false;
	float variable = 0.0f;
	public final int vertexPerQuad = 4;
	long FPSTimer = 0, prevFrameTime= 0, frames = 0;
	
	float x = 0f, y = 0f, z = 0f;
	
	
	private float heading;
	public float lookUpDown, lookLeftRight = 0f;
	private static float one_degree = 3.1415926535898f / 180;   //    
	private float dx = 0, dy = 0, dz = 0;				//   1 
	
	
	World world = new World();
    //Sphere sphere = new Sphere(5, 1);
    //Sphere sphere2 = new Sphere(5, 1);
	
	
	private org.lwjgl.util.glu.Sphere sphere = new org.lwjgl.util.glu.Sphere();
	public static float xLenght = 1, yLenght = 1, zLenght = 1;
	public static int xIters = 1, yIters = 1, zIters = 1;
	private boolean initSomething = false;
	public static int SPHERE = 550;
	private float angle = 0;
	
	private static Thread thread;
	private Model model;
	
	private float radiusAdd = 1;
		
	public static void main(String[] args) throws IOException {
		Gravitation draw = new Gravitation();
		boolean nonRelative = false;
		for (int i = 0; i < args.length; i++) {
			System.out.println("argument" + i + ": " + args[i]);
			if (args[i].equals("-nonRelative")) nonRelative = true;
		}
		
		JFrame frame = new JFrame("People can fly");				//     
		frame.setLayout(new BorderLayout());
		frame.add(draw, BorderLayout.CENTER);		
		Dimension size = new Dimension(WIDTH, HEIGHT);
		frame.setPreferredSize(size);
		frame.setMaximumSize(size);
		frame.setMinimumSize(size);
		frame.pack();										//     (  setSize()  ..)
		if (!nonRelative) frame.setLocationRelativeTo(null);		//     
		else frame.setLocation(0, 0);
		frame.setResizable(false);							//    
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);   //  JFrame   (   )
		frame.setVisible(true);
		
		draw.run();
		frame.dispose();
	}
	public void init() {
		model = Loader.loadFile();
		
		x = (model.xMin + model.xMax)/2f;
		y = (model.yMin + model.yMax)/2f;
		float screenRatio = WIDTH * 1.0f / (HEIGHT * 1.0f);
		float xLength = (model.xMax - model.xMin) / screenRatio;
		float yLength = model.yMax - model.yMin;
		float maxLength = (xLength >= yLength) ? xLength : yLength;
		float tg = 1.20711f;			// th(67.5)/2
		float shift = 1.1f;
		z = (maxLength * tg + model.zMax) * shift;
	}
	public void run(){
		
		init();
		opengl = new OpenGL(this);
		requestFocus();
		gameRunning = true;
		something();
		Textures.loadFilteredLinear();
		
		while (gameRunning) {
			control.getControl();
			if (Display.isCloseRequested() || control.keys[control.KEY_ESCAPE]){gameRunning = false;}
			Display.sync(60);
			//Display.setSwapInterval(1);
			Display.update();
			gravitation2D();
		}
		
		opengl.closeOpenGL();
		
	}

	public void something(){
		
        glLineWidth(1.0f);
		world.clear();
        glClearColor(0.8f, 0.9f, 1.0f, 1.0f);
        
        for (int i = 0; i < model.particles.length; i++) {
        	Particle p = model.particles[i];
        	float x = p.R.x;
        	float y = p.R.y;
        	float z = p.R.z;
        	int color = p.color;
        	float radius = 0;
        	radius = p.radius + radiusAdd;
			drawSphere(x, y, z, color, radius);
		}
    	
        
        // TODO      
        float radius = model.particles[0].radius * radiusAdd;
        
        glNewList(SPHERE,GL_COMPILE);
        	int count = model.particles.length;
        	if (count < 217) sphere.draw(radius, 30, 30);
        	else if (count < 12*12*12+1) sphere.draw(radius, 10, 10);
        	else if (count < 100000) sphere.draw(radius, 6, 6);
        	else sphere.draw(radius, 6, 6);
        glEndList();
        
        
        
        initSomething = true;
        
	}
	
	public void drawSphere(float x, float y, float z, int color, float radius){
        
//    	Sphere sphere = new Sphere(1, 0.2f, 0.5f, 0.3f, 0.7f);
		if (color == 0) color = 0x008050a0;
    	Sphere sphere = new Sphere(1, radius, color);
    	sphere.setR(new Vector().setVector(x, y, z));
    	world.addSphere(sphere);
	}
	
	public synchronized void start() {
		if (gameRunning) return;
		gameRunning = true;
		System.out.println(this);
		thread = new Thread(this);
		System.out.println(thread);
		thread.start();
	}

	public synchronized void stop() {
		if (!gameRunning) return;
		gameRunning = false;
		try {
			thread.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	
	
	public void gravitation2D(){
		
		if (!initSomething) something();
		
		if (control.keys[control.KEY_1]){ xLenght -= 0.2f; initSomething = false;}
		if (control.keys[control.KEY_2]){ xLenght += 0.2f; initSomething = false;}
		if (control.keys[control.KEY_3]){ yLenght -= 0.2f; initSomething = false;}
		if (control.keys[control.KEY_4]){ yLenght += 0.2f; initSomething = false;}
		if (control.keys[control.KEY_5]){ zLenght -= 0.2f; initSomething = false;}
		if (control.keys[control.KEY_6]){ zLenght += 0.2f; initSomething = false;}
		
		if (control.keys[control.KEY_I]){ xIters -= 1; initSomething = false;}
		if (control.keys[control.KEY_O]){ xIters += 1; initSomething = false;}
		if (control.keys[control.KEY_J]){ yIters -= 1; initSomething = false;}
		if (control.keys[control.KEY_K]){ yIters += 1; initSomething = false;}
		if (control.keys[control.KEY_N]){ zIters -= 1; initSomething = false;}
		if (control.keys[control.KEY_M]){ zIters += 1; initSomething = false;}
		
		if (control.keys[control.KEY_R] && !control.keysPressed[control.KEY_LSHIFT]){
			radiusAdd *= 0.5f;
			initSomething = false;
		}
		if (control.keys[control.KEY_R] && control.keysPressed[control.KEY_LSHIFT]){
			radiusAdd *= 2f;
			initSomething = false;
		}
		
		if (control.keys[control.KEY_MINUS]) i--;
		if (control.keys[control.KEY_EQUALS]) i++;
		
		
        moving();
		
		//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		//  ,  
        //glLoadIdentity();                         				//  
		glEnable(GL_TEXTURE_2D);
		//glEnable(GL_DEPTH);
		glEnable(GL_DEPTH_TEST);
		
		
		
		
        glBindTexture(GL_TEXTURE_2D, Textures.white.getTextureID());
        glColor3f(1, 1, 1);
//        glTranslatef(0, -10, -10);
        glTranslatef(0, 0, 0);
        
	    glColor4f(0.9f, 0.5f, 0.25f, 1);
		//world.update();
	    angle += i/20f;
	    glPushMatrix();
    		glTranslatef(((xIters - 1)/2f)*xLenght, 0, ((zIters - 1)/2f)*zLenght);
        	glRotatef(angle, 0, 1, 0);
    		glTranslatef(-((xIters - 1)/2f)*xLenght, 0, -((zIters - 1)/2f)*zLenght);
        	world.draw();
        glPopMatrix();
        
        GL11.glEnable(GL11.GL_BLEND);
		//glBlendFunc(GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR);
		//glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		//glEnable(GL_DEPTH);
		//glEnable(GL_DEPTH_TEST);
		//glDisable(GL_DEPTH);
		//glDisable(GL_DEPTH_TEST);
        
		
		//  XZ ()
	    glColor4f(1.0f, 1.0f, 1.0f, 0.8f);
		glBindTexture(GL_TEXTURE_2D, Textures.teormeh.getTextureID());
		int yoffset = - 50;
		glBegin(GL_QUADS);
        	glTexCoord2f(0.0f, 0.0f);
			glVertex3f(-500, yoffset, -500);
        	glTexCoord2f(0.0f, 100f);
			glVertex3f(-500, yoffset, 500);
        	glTexCoord2f(100f, 100f);
			glVertex3f(500, yoffset, 500);
        	glTexCoord2f(100f, 0.0f);
			glVertex3f(500, yoffset, -500);
		glEnd();
        
		
		
        GL11.glDisable(GL11.GL_BLEND);
		//glEnable(GL_DEPTH);
		//glEnable(GL_DEPTH_TEST);
		//glDisable(GL_DEPTH);
		//glDisable(GL_DEPTH_TEST);
        
        
        //sphere.set_dA(new Vector().setVector(0.01f, 0.0f, 0.0f));
        /*if (sphere.getPosition().getY() <= 0 + sphere.getRadius()){
        	sphere.setV(new Vector().setVector(0.0f, Math.abs(sphere.getV().getY())*0.1f, 0.0f));
        	sphere.add_A(Vector.scalarByVector(-1, World.g_metersPerSquareSecond));
        }*/
		
        
        
        /*
	    glColor3f(1.0f, 0.6f, 0.6f);
        sphere2.move();
        glPushMatrix();
        glTranslatef(sphere2.getPosition().getX(), sphere2.getPosition().getY(), sphere2.getPosition().getZ());
		glBindTexture(GL_TEXTURE_2D, Textures.stone.getTextureID());
		sphere2.draw();
        glPopMatrix();
        */
	}
	
	public void FPSTimer(){
		
		FPSTimer += System.nanoTime() - prevFrameTime;
		prevFrameTime = System.nanoTime();
		frames++;
		if (FPSTimer > 1000*1000*1000) {
			System.out.println(frames);
			
			frames = 0;
			FPSTimer = 0;
		}
		
	}
	public void moving(){
        if (control.LookUp){
	    	 lookUpDown -= 1.0f;
        }
        
        if (control.LookDown){
	    	 lookUpDown += 1.0f;
        }
        
        if (control.LookRight){
	    	 lookLeftRight -= 1.0f;
	    	 heading = lookLeftRight;
        }
        
        if (control.LookLeft){
	    	 lookLeftRight += 1.0f;
	    	 heading = lookLeftRight;
        }
        
        
        
        lookLeftRight -= control.LookY;
        lookUpDown -= control.LookX;
        
        
        
        heading = lookLeftRight;										// ?   
		
        if (lookUpDown > 90) lookUpDown = 90;
        if (lookUpDown < -90) lookUpDown = -90;
        
        
        
        if (control.GoForward){
			 dx += (float) -Math.sin(heading * one_degree) * 0.05f;
			 dz += (float) -Math.cos(heading * one_degree) * 0.05f;
        }
        
        if (control.GoBackward){
	    	 dx += (float) Math.sin(heading * one_degree) * 0.05f;
	    	 dz += (float) Math.cos(heading * one_degree) * 0.05f;
        }
        
        if (control.GoRight){
	    	 dx += (float) Math.cos(heading * one_degree) * 0.05f;
	    	 dz += (float) -Math.sin(heading * one_degree) * 0.05f;
        }
        
        if (control.GoLeft){
	    	 dx += (float) -Math.cos(heading * one_degree) * 0.05f;
	    	 dz += (float) Math.sin(heading * one_degree) * 0.05f;
        }
		//if (control.keysPressed[control.KEY_W] || control.keysPressed[control.KEY_UP]) z -= 0.03;
		//if (control.keysPressed[control.KEY_S] || control.keysPressed[control.KEY_DOWN]) z += 0.03;
		//if (control.keysPressed[control.KEY_A] || control.keysPressed[control.KEY_LEFT]) x -= 0.03;
		//if (control.keysPressed[control.KEY_D] || control.keysPressed[control.KEY_RIGHT]) x += 0.03;
        
        int speedUp;
        if (control.keysPressed[control.KEY_LSHIFT]) speedUp = 10; else speedUp = 1 ;
        
        
		if (control.keysPressed[control.KEY_SPACE]) y += 0.03*speedUp;
		if (control.keysPressed[control.KEY_LCONTROL]) y -= 0.03*speedUp;
        
		
		
		
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// ?  ,  
        glLoadIdentity();                         				//  
        
        
        glRotatef(lookUpDown,1.0f,0.0f,0.0f);						//    x
        glRotatef(-lookLeftRight,0.0f,1.0f,0.0f);					//    y
        
        
        
        
		glTranslatef(-x, -y, -z);
    	
        float lightPosition[] = { 50.0f, 50.0f, -50.0f, 0.5f }; // Light Position ( NEW )
        ByteBuffer temp = ByteBuffer.allocateDirect(16);
        temp.order(ByteOrder.nativeOrder());
        GL11.glLight(GL11.GL_LIGHT1, GL11.GL_POSITION,(FloatBuffer)temp.asFloatBuffer().put(lightPosition).flip());
        
    	x += dx*speedUp;
    	z += dz*speedUp;
    	dx = 0;
    	dz = 0;
	}
	
	public static List<Float> addMassToList(List<Float> list, float[] mass){
		
		for (int i = 0; i < mass.length; i++) {
			list.add(mass[i]);
		}
		
		return list;
		
	}
	
	public static float[] convertListToMass(List<Float> list){
		
		float[] mass = new float[list.size()];
		
		for (int i = 0; i < mass.length; i++) {
			mass[i] = list.get(i);
		}
		
		return mass;
		
	}
	
	
	
	


}
