package Gravitation;


import static org.lwjgl.opengl.GL11.*;

import java.awt.image.BufferedImage;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.IntBuffer;

import org.lwjgl.BufferUtils;
import org.lwjgl.util.glu.GLU;

public class TALTexture {

	private int[][] pixels;
	IntBuffer id;
	
	
	public TALTexture(BufferedImage image){
		//image.getData().getPixels(image.getMinX(), image.getMinY(), image.getWidth(), image.getHeight(), height);
		
		
		pixels = new int[image.getWidth()][image.getHeight()];
		
		for (int i = 0; i < image.getWidth(); i++) {
			for (int j = 0; j < image.getHeight(); j++) {
				pixels[i][j] = image.getRGB(i, j);
			}
		}
		
		
		
		
		id = ByteBuffer.allocateDirect(4).asIntBuffer();
        glGenTextures(id);
        glBindTexture(GL_TEXTURE_2D, id.get(0));
        
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
        // GL_LINEAR GL_NEAREST
        
        
        
        ByteBuffer imageBB = ByteBuffer.allocateDirect(pixels.length * pixels[0].length * 3);
        
        //    ,    
        for (int j = 0; j < pixels[0].length; j++) {
			for (int i = 0; i < pixels.length; i++) {
	        	byte r = (byte) ((pixels[i][j] & 0x00FF0000) >> 16);
	        	byte g = (byte) ((pixels[i][j] & 0x0000FF00) >> 8);
	        	byte b = (byte) ((pixels[i][j] & 0x000000FF));
				imageBB.put(new byte[]{r, g, b});
			}
		}
        
        
        imageBB.position(0);
        
        glTexImage2D(
        		GL_TEXTURE_2D, 0, GL_RGB, pixels.length, pixels[0].length,			// 16 = 2**4
        		0, GL_RGB, GL_UNSIGNED_BYTE, imageBB);
		
	}
	public TALTexture(int[][] pixels){
		
		id = ByteBuffer.allocateDirect(4).asIntBuffer();
        glGenTextures(id);
        glBindTexture(GL_TEXTURE_2D, id.get(0));
        
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
        // GL_LINEAR GL_NEAREST
        
        
        
        
        
        ByteBuffer imageBB = ByteBuffer.allocateDirect(pixels.length * pixels[0].length * 3);
        
        //    ,    
        for (int j = 0; j < pixels[0].length; j++) {
			for (int i = 0; i < pixels.length; i++) {
	        	byte r = (byte) ((pixels[i][j] & 0x00FF0000) >> 16);
	        	byte g = (byte) ((pixels[i][j] & 0x0000FF00) >> 8);
	        	byte b = (byte) ((pixels[i][j] & 0x000000FF));
				imageBB.put(new byte[]{r, g, b});
			}
		}
        
        
        imageBB.position(0);
        
        glTexImage2D(
        		GL_TEXTURE_2D, 0, GL_RGB, pixels.length, pixels[0].length,			// 16 = 2**4
        		0, GL_RGB, GL_UNSIGNED_BYTE, imageBB);
        
	}
	public TALTexture(int[] pixel, int width){
		
		//id = ByteBuffer.allocateDirect(4).asIntBuffer();
		id = BufferUtils.createIntBuffer(1);
        glGenTextures(id);
        glBindTexture(GL_TEXTURE_2D, id.get(0));
        
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
        // GL_LINEAR GL_NEAREST
        
        
        
        
        /*
        ByteBuffer imageBB = ByteBuffer.allocateDirect(width * pixel.length/width * 3);
        //ByteBuffer imageBB = BufferUtils.createByteBuffer(width * pixel.length/width * 3);
        
        
        //    ,    
        for (int j = 0; j < pixel.length/width; j++) {
			for (int i = 0; i < width; i++) {
				System.out.println(i + j*width);
	        	byte r = (byte) ((pixel[i + j*width] & 0x00FF0000) >> 16);
	        	byte g = (byte) ((pixel[i + j*width] & 0x0000FF00) >> 8);
	        	byte b = (byte) ((pixel[i + j*width] & 0x000000FF));
	        	System.out.println(r + " " + g + " " + b);
				imageBB.put(new byte[]{r, g, b});
			}
		}
        
        System.out.println(imageBB);
        
        //imageBB.position(0);
        imageBB.flip();
        
        for (int i = 0; i < 4; i++) {
            System.out.println(imageBB.get() + " " + imageBB.get() + " " + imageBB.get());
		}
        
        
        imageBB.position(0);
        */
        
        
        
        
        
        
        
        //ByteBuffer imageBB = BufferUtils.createByteBuffer(width * pixel.length/width * 3);
        ByteBuffer imageBB = ByteBuffer.allocateDirect(12);
        
        imageBB.order(ByteOrder.nativeOrder());
        imageBB.put(new byte[]{-1, -1, -1,    -1, -1, -1,    -1, -1, -1,    -1, -1, -1}, 0, 12);
        imageBB.flip();

        glTexImage2D(
        		GL_TEXTURE_2D, 0, GL_RGB, width, pixel.length/width,			// 16 = 2**4
        		0, GL_RGB, GL_UNSIGNED_BYTE, imageBB);

	}
	public TALTexture(){
		
	}
	
	
	public int getTextureID(){
		return id.get(0);
	}

	public void colorizeOLD(int R, int G, int B){
		
		//glDeleteTextures(texture);

        glBindTexture(GL_TEXTURE_2D, id.get(0));
		
        ByteBuffer imageBB = ByteBuffer.allocateDirect(pixels.length * pixels[0].length * 3);
        
        //    ,    
        for (int j = 0; j < pixels[0].length; j++) {
			for (int i = 0; i < pixels.length; i++) {
				
				int rInt = ((pixels[i][j] & 0x00FF0000) >> 16) + R;
				if (rInt > 255) rInt = 255;
				if (rInt < 0) rInt = 0;
				
				int gInt = ((pixels[i][j] & 0x0000FF00) >> 8) + G;
				if (gInt > 255) gInt = 255;
				if (gInt < 0) gInt = 0;
				
				int bInt = ((pixels[i][j] & 0x000000FF)) + B;
				if (bInt > 255) bInt = 255;
				if (bInt < 0) bInt = 0;
				
	        	byte r = (byte) rInt;
	        	byte g = (byte) gInt;
	        	byte b = (byte) bInt;
				imageBB.put(new byte[]{r, g, b});
			}
		}
        
        
        imageBB.position(0);
        
        
        /*glTexImage2D(
        		GL_TEXTURE_2D, 0, GL_RGB, pixels.length, pixels[0].length,			// 16 = 2**4
        		0, GL_RGB, GL_UNSIGNED_BYTE, imageBB);
		*/
        
        GLU.gluBuild2DMipmaps(GL_TEXTURE_2D, 4, pixels.length, pixels[0].length, GL_RGB, GL_UNSIGNED_BYTE, imageBB);
		
	}
	public void colorize(int R, int G, int B){
        //glEnable(GL_BLEND);
        //glBlendFunc(GL_SRC_ALPHA,GL_ONE); //    ,
		//glColor4f(1.0f,1.0f,1.0f,0.8f);   //  , 50%  ()
	}


	
	public static TALTexture makeGradient(){
		
		TALTexture talTexture = new TALTexture();
		
		talTexture.id = BufferUtils.createIntBuffer(1);
		
		//id = ByteBuffer.allocateDirect(4).asIntBuffer();
        glGenTextures(talTexture.id);
        glBindTexture(GL_TEXTURE_2D, talTexture.id.get(0));
        
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
        // GL_LINEAR GL_NEAREST
        
        
        
        
        
        ByteBuffer imageBB = ByteBuffer.allocateDirect(256 * 1 * 3);
        //ByteBuffer imageBB = BufferUtils.createByteBuffer(width * pixel.length/width * 3);
        
        
        //    ,    
		for (int i = 0; i < 256; i++) {
	        byte r = (byte) i;
	        byte g = (byte) i;
	        byte b = (byte) i;
			imageBB.put(new byte[]{r, g, b});
		}  
        
        imageBB.position(0);
        
        System.out.println(imageBB); 		
		
        
        glTexImage2D(
        		GL_TEXTURE_2D, 0, GL_RGB, 256, 1,			// 16 = 2**4
        		0, GL_RGB, GL_UNSIGNED_BYTE, imageBB);
		
		return talTexture;
		
	}
}
