package Gravitation.world;

import static org.lwjgl.opengl.GL11.glCallList;

import org.lwjgl.opengl.GL11;

import Gravitation.Gravitation;

public class Sphere {
	
	private float mass;
	private float radius;
	private byte r, g, b;
	
	private Vector R = new Vector();
	private Vector dR = new Vector();
	private Vector V = new Vector();
	private Vector dV = new Vector();
	private Vector A = new Vector();
	private Vector dA = new Vector();
	
	private World world;
	private org.lwjgl.util.glu.Sphere sphere = new org.lwjgl.util.glu.Sphere();
	
	public boolean collisionChecked = false;
	public boolean isXEdge = false;
	public boolean isYEdge = false;
	public boolean isZEdge = false;
	
	
	public Sphere(float mass, float radius, int color){
		this.mass = mass;	
		this.radius = radius;
		r = (byte) ((color & 0x00FF0000) >> 16);
		g = (byte) ((color & 0x0000FF00) >> 8);
		b = (byte) (color & 0x000000FF);
	}
	public Sphere(float mass, float radius, float r, float g, float b){
		this.mass = mass;	
		this.radius = radius;
		this.r = (byte) (r * 255);
		if (r > 1) this.r = (byte)255;
		if (r < 0) this.r = 0;
		this.g = (byte) (g * 255);
		if (g > 1) this.g = (byte)255;
		if (g < 0) this.g = 0;
		this.b = (byte) (b * 255);
		if (b > 1) this.b = (byte)255;
		if (b < 0) this.b = 0;
	}
	
	public float getRadius(){
		return radius;
	}
	
	
	public Sphere setPSA(Vector position, Vector speed, Vector acceleration){
		this.R.setVector(position);
		this.R.setVector(speed);
		this.R.setVector(acceleration);
		return this;
	}
	public Sphere setR(Vector R){
		this.R.setVector(R);
		return this;
	}

	public Vector getPosition(){
		return R;
	}

	public void move(){									//   ,   
		
		
		
		//add_A(World.g_metersPerSquareSecond);
		
		dV = Vector.scalarByVector(World.dt, A);
		V = Vector.vectorPlusVector(V, dV);
		
		dR = Vector.scalarByVector(World.dt, V);
		if (Vector.vectorPlusVector(R, dR).getY() <= 0 + radius){	//         
			R.setVector(R.getX() + dR.getX(), 1, R.getZ() + dR.getZ());	//   -   
		} else {
			R = Vector.vectorPlusVector(R, dR);							//    
		}
		
		
		//System.out.println("speed " + V + "     koords " + R);
		
		
		
		
		dR.setNull();
		dV.setNull();
		A.setNull();
		
	}

	public void add_A(Vector vector){					//   ()
		A = Vector.vectorPlusVector(A, vector);
	}
	
	public void draw(){
		
		GL11.glColor3ub(r, g, b);
		
		//sphere.draw(radius, 4, 4);
        glCallList(Gravitation.SPHERE);
		
		//GL11.glPushMatrix();
		//GL11.glTranslatef(-0.6f, 1.3f, 0);
		//GL11.glPopMatrix();
	
	}




}
