package Gravitation.world;

public class Vector {
	
	private float x, y, z;
	
	public Vector setVector(float x, float y, float z){
		this.x = x;
		this.y = y;
		this.z = z;
		return this;
	}
	public Vector setVector(Vector vector){
		this.x = vector.x;
		this.y = vector.y;
		this.z = vector.z;
		return this;
	}
	public Vector setNull(){
		x = 0;
		y = 0;
		z = 0;
		return this;
	}
	public float getX(){
		return this.x;
	}
	public float getY(){
		return this.y;
	}
	public float getZ(){
		return this.z;
	}
	public float getModule(){		//   
		return (float) Math.sqrt(x*x + y*y + z*z);
	}
	public float getSquare(){
		return (x*x + y*y + z*z);
	}
	
	public Vector getNormalized(){
		float lenght = 1/this.getModule();
		return scalarByVector(lenght, this);
	}
	
	
	
	public String toString(){
		return ("x: " + x + "  y: " + y + "  z: " + z);
	}
	
	
	
	
	
	public float scalarProduct(Vector vector2){
		return this.x*vector2.x + y*vector2.y + z*vector2.z;
	}
	
	public static Vector vectorPlusVector(Vector vector1, Vector vector2){
		float x = vector1.getX() + vector2.getX();
		float y = vector1.getY() + vector2.getY();
		float z = vector1.getZ() + vector2.getZ();
		return new Vector().setVector(x, y, z);
	}
	public static Vector scalarByVector (float scalar, Vector vector){		
		return new Vector().setVector(vector.x*scalar, vector.y*scalar, vector.z*scalar);
	}
	
}
