package a3rWriter;

import java.io.*;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.IntBuffer;
import java.util.Random;

public class WriteA3R {

	public static void main(String[] args) {
		try
		{
			new WriteA3R().start();
		}
		catch (IOException e) {System.err.println("ERMAC 1");}
		
		
	}
	
	private void start() throws IOException {
		String path = "someFile2.a3r";
		OutputStream outStream = null;
		
		//   
		outStream = new FileOutputStream(path);
		outStream = new BufferedOutputStream(outStream);
		
		int count = 800;
		double r = 1;
		
		// header
		ByteBuffer bBuf = ByteBuffer.allocate(40);
		bBuf.put("a3r\0".getBytes());						// 4		file_type
		bBuf.order(ByteOrder.LITTLE_ENDIAN);
		bBuf.putInt(count);									// 4		count
		bBuf.putInt(0x28);									// 4		data_start
//		bBuf.put("e\0\0\0\0\0\0\0\0\0\0\0".getBytes());		// 12		version
		bBuf.put("java\0\0\0\0\0\0\0\0".getBytes());		// 12		version
		bBuf.putDouble(r);									// 8		r
		bBuf.putInt(0);										// 4		count_1
		bBuf.putInt(0);										// 4		unknown
		outStream.write(bBuf.array());
		
		
		// data
		for (int i = 0; i < count; i++) {
			bBuf = ByteBuffer.allocate(12);
			bBuf.order(ByteOrder.LITTLE_ENDIAN);
			bBuf.putFloat(60*(float)Math.cos(i*3.14/count*2));
			bBuf.putFloat(60*(float)Math.sin(i*3.14/count*2));
			bBuf.putFloat(0);
			outStream.write(bBuf.array());
		}
		for (int i = 0; i < count; i++) {
			bBuf = ByteBuffer.allocate(4);
			bBuf.order(ByteOrder.BIG_ENDIAN);
			bBuf.putInt(0x0000ff00);
			outStream.write(bBuf.array());
		}
		for (int i = 0; i < count; i++) {
			bBuf = ByteBuffer.allocate(4);
			bBuf.order(ByteOrder.BIG_ENDIAN);
			bBuf.putInt(0x0000803f);						// ?? ,      r
			outStream.write(bBuf.array());
		}
		
		outStream.flush();								//   ,   
		outStream.close();
	}

}
